var OPTION_ACTIVATION_KIND="activation.kind";
var OPTION_ACTIVATION_CONDITION="activation.condition";
var OPTION_SELECTION_LINK="selectionlink";
var OPTION_USERNAME="username";
var OPTION_RESTRICTED_SPECIAL="restrictedspecial";
var OPTION_USER_WIKI="userwiki";
var OPTION_HOMEONCHANGE="homeonchange";
var OPTION_LINKDIALOG="linkdialog";
var OPTION_ACTIVE_COUNT="active.count";
var OPTION_ACTIVE_URL="active.url";
var OPTION_ACTIVE_LABEL="active.label";
var OPTION_ACTIVE_LANGUAGE="active.language";

var IMAGE_ON="chrome://wikipedia/skin/select_on.gif";
var IMAGE_OFF="chrome://wikipedia/skin/select_off.gif";

var stringBundle=null;
var wbPrefs=null;

function clickStandardWiki(event)
{
	tree=document.getElementById('tree-standard');
	item=tree.view.getItemAtIndex(tree.currentIndex);
	label=item.firstChild.firstChild.nextSibling.getAttribute("label");
	active=item.firstChild.firstChild;
	image=active.getAttribute("src");
	if (image==IMAGE_OFF) {
		active.setAttribute("src",IMAGE_ON);
	}
	else {
		active.setAttribute("src",IMAGE_OFF);
	}
}

function addStandardWiki(parentId,code,language,english,url) {
	var wiki_tree=document.getElementById(parentId);
	select_image=IMAGE_OFF;
	var count_active=wbPrefs.getIntPref(OPTION_ACTIVE_COUNT);
	for (i=0;i<count_active;i++) {
		var active_url=wbPrefs.getCharPref(OPTION_ACTIVE_URL+i);
		if (active_url==url) {
			select_image=IMAGE_ON;
		}
	}
	var item=document.createElement('treeitem');
	var row=document.createElement('treerow');
	var cell=document.createElement('treecell');
	cell.setAttribute("src",select_image);
	row.appendChild(cell);
	cell=document.createElement('treecell');
	cell.setAttribute("label",code);
	row.appendChild(cell);
	cell=document.createElement('treecell');
	cell.setAttribute("label",language);
	row.appendChild(cell);
	cell=document.createElement('treecell');
	cell.setAttribute("label",english);
	row.appendChild(cell);
	cell=document.createElement('treecell');
	cell.setAttribute("label",url);
	row.appendChild(cell);
	item.appendChild(row);
	wiki_tree.appendChild(item);
}

function loadStandardWikis() {
	var projects=['wikipedia','wiktionary','wikibooks','wikiquote','wikisource','wikinews','special'];
	var nodelist = wikipedia.getNodes("chrome://wikipedia/content/wiki_projects.xml","/languages/language");
	for(var i=0; i < nodelist.length; i++) {
		node=nodelist[i];
		var code = document.evaluate("code/text()",node,null,0,null).iterateNext();
		if (code!=null) {
			code = code.nodeValue;
		}
		else {
			code = "";
		}
		var name = document.evaluate("name/text()",node,null,0,null).iterateNext().nodeValue;
		var english = document.evaluate("name_english/text()",node,null,0,null).iterateNext().nodeValue;
		for (p=0;p<projects.length;p++) {
			var url = document.evaluate(projects[p]+"/text()",node,null,0,null).iterateNext();
			if (url!=null) {
				addStandardWiki("projects-"+projects[p],code,name,english,url.nodeValue);
			}
		}
	}
}

function onLoad()
{
	stringBundle = document.getElementById("wikipediastrings");
	wbPrefs = getPreferences();
	try{
		document.getElementById("wikipedia-activation-kind").selectedIndex = wbPrefs.getIntPref(OPTION_ACTIVATION_KIND);
		document.getElementById("wikipedia-activation-condition").value = wbPrefs.getCharPref(OPTION_ACTIVATION_CONDITION);
		document.getElementById(OPTION_USERNAME).value = wbPrefs.getCharPref(OPTION_USERNAME);
		document.getElementById(OPTION_SELECTION_LINK).selectedIndex = wbPrefs.getIntPref(OPTION_SELECTION_LINK);
		document.getElementById(OPTION_RESTRICTED_SPECIAL).checked= wbPrefs.getBoolPref(OPTION_RESTRICTED_SPECIAL);
		document.getElementById(OPTION_HOMEONCHANGE).checked= wbPrefs.getBoolPref(OPTION_HOMEONCHANGE);
		document.getElementById(OPTION_LINKDIALOG).checked= wbPrefs.getBoolPref(OPTION_LINKDIALOG);
		loadStandardWikis();
		loadUserWikis();
	} catch (e){
		var alertText = stringBundle.getString("wikipedia.settings.loaderr");
		alert(alertText + e);
	}           
	if (parent.initPanel) {
		parent.initPanel("chrome://wikipedia/content/wikipedia_settings.xul");
	}
}

function storeStandardWikis() {
	var wiki_count=0;
	wiki_projects=document.getElementById('wiki-projects').childNodes;
	for (project_index=0;project_index<wiki_projects.length;project_index++) {
		project=wiki_projects[project_index].firstChild.nextSibling;
		projectName=wiki_projects[project_index].firstChild.firstChild.getAttribute("label");
		items=project.childNodes;
		for (i=0;i<items.length;i++) {
			image=items[i].firstChild.firstChild.getAttribute('src');
			if (image==IMAGE_ON) {
				code=items[i].firstChild.firstChild.nextSibling.getAttribute("label");
				url=items[i].firstChild.firstChild.nextSibling.nextSibling.nextSibling.nextSibling.getAttribute("label");
				label=projectName+" ("+code+")";
				language=code;
				if (projectName=="Wikimedia") {
					label=items[i].firstChild.firstChild.nextSibling.nextSibling.nextSibling.getAttribute("label");
					language="en";
				}
				wbPrefs.setCharPref(OPTION_ACTIVE_URL+wiki_count,url);
				wbPrefs.setCharPref(OPTION_ACTIVE_LABEL+wiki_count,label);
				wbPrefs.setCharPref(OPTION_ACTIVE_LANGUAGE+wiki_count,language);
				wiki_count++;
			}
		}
	}
	if ((wiki_count==0) && (document.getElementById('projects-user').childNodes.length==0)) {
		//TODO
	}
	wbPrefs.setIntPref(OPTION_ACTIVE_COUNT,wiki_count);
}

function wikipediaAccept()
{
	try{
		// store preferences
		wbPrefs.setIntPref(OPTION_ACTIVATION_KIND,document.getElementById("wikipedia-activation-kind").selectedIndex);
		wbPrefs.setIntPref(OPTION_SELECTION_LINK,document.getElementById(OPTION_SELECTION_LINK).selectedIndex);
		wbPrefs.setCharPref(OPTION_ACTIVATION_CONDITION,document.getElementById("wikipedia-activation-condition").value);
		wbPrefs.setCharPref(OPTION_USERNAME,document.getElementById(OPTION_USERNAME).value);
		wbPrefs.setBoolPref(OPTION_RESTRICTED_SPECIAL,document.getElementById(OPTION_RESTRICTED_SPECIAL).checked);
		wbPrefs.setBoolPref(OPTION_HOMEONCHANGE,document.getElementById(OPTION_HOMEONCHANGE).checked);
		wbPrefs.setBoolPref(OPTION_LINKDIALOG,document.getElementById(OPTION_LINKDIALOG).checked);
		storeStandardWikis();
		storeUserWikis();
		// use new preferences
//TODO:		document.getElementById('wikipedia-specialpages-restricted').setAttribute("hidden",!wbprefs.getBoolPref("restrictedspecial"));
	} catch (e){
		var alertText = stringBundle.getString("wikipedia.settings.saveerr");
		alert(alertText + e);
	}
	return true;
}

function addUserWikiItem(label,url) {
	var item=document.createElement('treeitem');
	var row=document.createElement('treerow');
	var cell=document.createElement('treecell');
	cell.setAttribute("label",label);
	row.appendChild(cell);
	cell=document.createElement('treecell');
	cell.setAttribute("label",url);
	row.appendChild(cell);
	item.appendChild(row);
	document.getElementById('projects-user').appendChild(item);
}

function addUserWiki() {
	var ok = [false];
	var params = ["","http://"];
	window.openDialog("chrome://wikipedia/content/wiki_properties.xul", "Wiki properties","chrome,modal,centerscreen,resizable",ok,params);
	if (ok[0]){
		var label=params[0];
		var url=params[1];
		addUserWikiItem(label,url);
	}	
}

function editUserWiki() {
	tree=document.getElementById('tree-user');
	item=tree.view.getItemAtIndex(tree.currentIndex);
	label=item.firstChild.firstChild.nextSibling.getAttribute("label");
	url=item.firstChild.firstChild.nextSibling.nextSibling.getAttribute("label");
	var ok = [false];
	var params = [label,url];
	window.openDialog("chrome://wikipedia/content/wiki_properties.xul", "Wiki properties","chrome,modal,centerscreen,resizable",ok,params);
	if (ok[0]){
		var label=params[0];
		var url=params[1];
		item.firstChild.firstChild.setAttribute("label",label);
		item.firstChild.firstChild.nextSibling.setAttribute("label",url);
	}
}

function deleteUserWiki() {
	tree=document.getElementById('tree-user');
	item=tree.view.getItemAtIndex(tree.currentIndex);
	document.getElementById('projects-user').removeChild(item);
	enableDelete(false);
}

function enableDelete(e) {
	document.getElementById('wiki-edit').disabled=!e;
	document.getElementById('wiki-delete').disabled=!e;
}

function storeUserWikis() {
	items=document.getElementById('projects-user').childNodes;
	for (i=0;i<items.length;i++) {
		wbPrefs.setCharPref(OPTION_USER_WIKI+"."+i+".label",items[i].firstChild.firstChild.getAttribute("label"));
		wbPrefs.setCharPref(OPTION_USER_WIKI+"."+i+".url",items[i].firstChild.firstChild.nextSibling.getAttribute("label"));
	}
	wbPrefs.setIntPref(OPTION_USER_WIKI+".count",items.length);
}

function loadUserWikis() {
	count=wbPrefs.getIntPref(OPTION_USER_WIKI+".count");
	for (i=0;i<count;i++) {
		label=wbPrefs.getCharPref(OPTION_USER_WIKI+"."+i+".label");
		url=wbPrefs.getCharPref(OPTION_USER_WIKI+"."+i+".url");
		addUserWikiItem(label,url);
	}
}

function updateLinkSelection() {
	disabled = !document.getElementById('linkdialog').checked;
	document.getElementById('wikipedia-selection-group').disabled = disabled;
	document.getElementById('edit-link-target').disabled = disabled;
	document.getElementById('edit-link-visible').disabled = disabled;
}